#include <iostream>
#include <SFML/Window.hpp>
#include "input.h"

using namespace std;

class TestKeysMap : public IKeysMap {
public:
    enum{LEFT_CLICK,RIGHT_CLICK,MIDDLE_CLICK,ACTION};
    TestKeysMap(){
        keys.push_back ({{LEFT_CLICK,input::MOUSE},sf::Mouse::Left,PRESSED} );
        keys.push_back ({{RIGHT_CLICK,input::MOUSE},sf::Mouse::Right,PRESSED} );
        keys.push_back ({{ACTION,input::CONTROLLER},sf::Joystick::X,PRESSED} );
    }

    static std::vector<Action> getTestContext()
    {
        return
        {
            {LEFT_CLICK,input::MOUSE},
            {RIGHT_CLICK,input::MOUSE},
            {ACTION,input::CONTROLLER}
        };
    }
};


int main()
{
    cerr << "Hello World!"<< endl;
    sf::Window* window= new sf::Window(sf::VideoMode(400,200),"testSparrowInput");
    Input myInput(window);

    Context context = Context("test",TestKeysMap::getTestContext());
    myInput.setKeysMap(TestKeysMap());
    myInput.addContext(context);
    myInput.setCurrentContext("test");

    while(!myInput.isCloseRequested())
    {
        myInput.updateEvents();
        for (Action action : myInput.getActions())
        {
            if (action.action == TestKeysMap::ACTION && action.source == input::CONTROLLER && action.controller_id == 0){
                std::cout << "Controllers connected: " << myInput.getControllersConnected().size();
//                for(auto controller : myInput.getControllersConnected())
  //                  std::cout <<  controller << " ";
                std::cout << std::endl;
            }
        }
    }
    /*    IKeysMap* keymap = new IKeysMap("test", 1);

//	keymap->setKeyBinding(ACTION_2,0,sf::Keyboard::Z);
//	keymap->setTypeAction(ACTION_2,KeysMap::RELEASED);
//	cerr << keymap->getKeyBinding(ACTION_1,0) << endl;
//	cerr << keymap->getTypeAction(ACTION_1) << endl;

//	KeyBindings keybind(myvector,keymap);
//	cerr << " Action : " <<	keybind.getReleasedAction(sf::Keyboard::Z) << endl;
//
//	myInput.setkeyBinding(ACTION_1,1,sf::Keyboard::A);
//	myInput.setkeyBinding(ACTION_1,2,sf::Keyboard::Z);
//	myInput.setkeyBinding(ACTION_2,1,sf::Keyboard::I);
//	myInput.setkeyBinding(ACTION_2,2,sf::Keyboard::O);

//	myInput.setTypeAction(ACTION_1, KeysMap::HOLD);
//	myInput.setTypeAction(ACTION_2, KeysMap::RELEASED);

	//myInput.test();

//	myInput.createContext("test", myvector);
//	myInput.setCurrentContext("test");
//	myInput.reloadKeyBindings();
//	int action;
//    bool run = true;
//    while(run){
//        myInput.updateEvents();
//		if (myInput.isCloseRequested()){
//			window->close();
//			run = false;
//		}
//		while (action = myInput.getAction() != NO_ACTION)
//			cout << "test " << action << endl;
//		window->display();
//    }*/
	cerr << "Successfully ended" << endl;
    return 0;
}
